

#include "OsaLinuxC.h"
#include "OsaLinuxRtl.h"
#include "OsaLinuxCpp.h"  

/*---------------------------------------------------------------------------*\  
 from OsaLinuxCppRtl.h OsaLinuxCppRtl.cpp
\*---------------------------------------------------------------------------*/

spinlock_t  *m_pSpinLock;           //it gets error if this is in OsaLinuxC.h
wait_queue_head_t *m_pWaitQueHead;


void OsaSpinLockImpl_Ctor(void *pSLock)
{
	m_pSpinLock = (spinlock_t *) pSLock;

	spin_lock_init(m_pSpinLock);
}

void OsaSpinLockImpl_Lock(void *pSLock, __u32 *flags)
{
    m_pSpinLock = (spinlock_t *) pSLock;

	spin_lock_irqsave(m_pSpinLock, *flags);
}

void OsaSpinLockImpl_Unlock(void *pSLock, __u32 savedFlags)
{
    m_pSpinLock = (spinlock_t *) pSLock;

	spin_unlock_irqrestore(m_pSpinLock, savedFlags);
}


void OsaEventImpl_Ctor(void *pWQHead)
{
	m_pWaitQueHead = (wait_queue_head_t *) pWQHead;

	init_waitqueue_head(m_pWaitQueHead);
}

void OsaEventImpl_wake_up(void *pWQHead)
{
	m_pWaitQueHead = (wait_queue_head_t *) pWQHead;

	wake_up(m_pWaitQueHead);

}


/*---------------------------------------------------------------------------*\  
 from OsaLinux.h and OsaLinux.cpp
\*---------------------------------------------------------------------------*/
  
wait_queue_head_t *m_pWaitQueHead;


void OsaLinuxUserEventDevice_Ctor(void *pWQHead)
{
	m_pWaitQueHead = (wait_queue_head_t *) pWQHead;

	init_waitqueue_head(m_pWaitQueHead);
}

void OsaLinuxUserEventDevice_wake_up(void *pWQHead)
{
	m_pWaitQueHead = (wait_queue_head_t *) pWQHead;

	wake_up(m_pWaitQueHead);
}

void OsaLinuxUserEventDevice_poll_wait(struct file *pFl, 
                                       void *pWQHead, 
                                       struct poll_table_struct *pPTable)
{
	m_pWaitQueHead = (wait_queue_head_t *) pWQHead;

  osalinux_poll_wait(pFl, pWQHead, pPTable);
}


/*---------------------------------------------------------------------------*\  
 from OsaLinux.h and OsaLinux.cpp
\*---------------------------------------------------------------------------*/

int OsaLinux_pci_present()
{
  return pci_present();
}


void OsaLinux_pci_read_config_word(struct pci_dev_otx *dev, int where, u16 *val)
{
  pci_read_config_word((struct pci_dev *)dev, where, val);
}


void OsaLinux_pci_read_config_dword(struct pci_dev_otx *dev, int where, u32 *val)
{
  pci_read_config_dword((struct pci_dev *)dev, where, val);
}


void OsaLinux_pci_write_config_dword(struct pci_dev_otx *dev, int where, u32 val)
{
  pci_write_config_dword((struct pci_dev *)dev, where, val);
}


struct pci_dev_otx * OsaLinux_pci_dev_g_fun1(void)
{
  return (struct pci_dev_otx *)pci_dev_g(pci_devices.next);
}


struct pci_dev_otx * OsaLinux_pci_dev_g_fun2(void)
{
  return (struct pci_dev_otx *)pci_dev_g(&pci_devices);
}


struct pci_dev_otx * OsaLinux_pci_dev_g_fun3(struct pci_dev_otx *pPciDevice)
{
  return (struct pci_dev_otx *) pPciDevice->global_list.next;  // casting 
}


int OsaLinux_osalinux_wait_event_timeout( OsaUint32 *pEventSet, 
                                         void *pWQHead, 
                                         OsaUint32 nWaitMaxMs
                                        )
{
  wait_queue_head_t *pWaitQueueHead;

  pWaitQueueHead = (wait_queue_head_t *)pWQHead;

  return osalinux_wait_event_timeout(pEventSet, pWaitQueueHead, nWaitMaxMs);
}


/*---------------------------------------------------------------------------*\
  from OsaLinux.h and OsaLinux.cpp

  for RedHat 9.0; in RedHat 8.0, it compiles without modifying followings
\*---------------------------------------------------------------------------*/

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,20) 
  #include <linux/module.h>  
#endif

void OsaLinux_MOD_INC_USE_COUNT(void)
{
   MOD_INC_USE_COUNT;
}


void OsaLinux_MOD_DEC_USE_COUNT(void)
{
   MOD_DEC_USE_COUNT;
}


const void * Osalinux_inter_module_get(const char * sModule)
{
  return inter_module_get(sModule);
}


void OsaLinux_inter_module_register(const char * sName, const void * pFunName)
{
  inter_module_register(sName, THIS_MODULE, pFunName);
}


void OsaLinux_inter_module_unregister(const char * sName)
{
  inter_module_unregister(sName);
}




