
/*---------------------------------------------------------------------------*\
  Note: starting from RedHat (kernel-2.4.18-14), OtxDrv gets compilation 
  errors, to cope with kernel and compiler (3.x) changes of RedHat 8.0 and 9.0, 
  functions using Linux kernel API in cpp files are segregated and put in 
  c files,  any cpp should NOT include this header file  
\*---------------------------------------------------------------------------*/

#ifndef OSA_LINUX_CPP_H
#define OSA_LINUX_CPP_H


#ifdef __cplusplus
extern "C" {
#else
#endif

#define new ident_new
#define delete ident_delete
#define class ident_class
#define virtual ident_virtual			//KERNEL_VERSION(2,4,0): conflict with "virtual" in header file <linux/mm.h>  
#define namespace ident_namespace


#include <linux/pci.h>			// for pci_present(), it includes <asm/linux.h> -> <linux/string.h> -- for size_t
#include <linux/poll.h>			// for poll_wait(), include <asm/poll.h>	and <linux/string.h>
#include <linux/proc_fs.h> 
#include <linux/delay.h> 

#include <linux/module.h>   
MODULE_LICENSE("GPL");       

#undef new
#undef delete
#undef class
#undef virtual		// KERNEL_VERSION(2,4,0)
#undef namespace	// KERNEL_VERSION(2,4,0)


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,0)
void osalinux_wake_up(struct wait_queue **wait_queue);
void osalinux_poll_wait(struct file *filp, struct wait_queue **wait_address, struct poll_table_struct *p);
#else
void osalinux_wake_up(wait_queue_head_t *wait_queue_head); 
void osalinux_poll_wait(struct file *filp, wait_queue_head_t *wait_address, struct poll_table_struct *p);  
#endif


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,0)    
int osalinux_wait_event_timeout(
  OsaUint32 *pEventSet, 
  struct wait_queue **ppWaitQueue, 
  OsaUint32 nWaitMaxMs
  );
#else
int osalinux_wait_event_timeout(
  OsaUint32 *pEventSet,
  wait_queue_head_t *pWaitQueueHead, 
  OsaUint32 nWaitMaxMs
  );
#endif




#ifdef __cplusplus
}
#endif

#endif  //OSA_LINUX_CPP_H





