
#include "../OsaRtl.h"  // For wchar_t with C compile
#include "OsaLinuxC.h"  


#ifdef __cplusplus
extern "C" {
#endif


struct proc_dir_entry_otx *OsaLinuxCreateProcDevice(const wchar_t *pwcsDeviceName, void *pContext);
void OsaLinuxRemoveProcDevice(struct proc_dir_entry_otx *pProcEntry);

// Entry functions that must be implemented by OsaLinux.cpp because OsaLinuxEntry.c calls them
extern int OsaLinuxDriverEntry(void);

extern int OsaLinuxOpenDeviceEntry(
  struct file *pFile, 
  void *pContext
  );
 
extern int OsaLinuxCloseDeviceEntry(
  struct file *pFile, 
  void *pContext
  );
 
extern int OsaLinuxIoDeviceControlEntry(
  void *pFile,
  void *pContext, 
  OsaUint32 nIoControlCode, 
  OsaLinuxIoCtlHdr *pHdr, 
  void *pSystemBuffer
  );

extern unsigned int OsaLinuxPollDeviceEntry(
  struct file *pFile, 
  void *pContext, 
  struct poll_table_struct *pPollTable
  );

extern void OsaLinuxRemoveDeviceEntry(void *pContext);
  
extern void OsaLinuxUnloadEntry();

// @todo: must find out if it's really necessary for OsaLinux.cpp to call this function which should
// only be called by the Linux kernel, really
void cleanup_module(void);         

#ifdef __cplusplus
}
#endif

