#ifndef OSA_MEMORY_H
#define OSA_MEMORY_H

#include "Api/OsaDef.h"
#include "Api/OtxType.h"

enum OsaMemoryPoolType {
  OSA_MEMORY_PAGED,
  OSA_MEMORY_NONPAGED
};

// memory descriptor structure
typedef struct {
  void *      pPhy;       // pointer to physical memory
  void *      pLog;       // pointer to virtual memory
  size_t      cbSize;     // size of allocated memory
  void *      pContext;   // typeless context
  OsaUint64   ui64Addr;
} OSA_MD, *POSA_MD;


#ifndef _PNH_DEFINED
typedef int (OSA_CDECL* _PNH)(size_t);
#define _PNH_DEFINED
#endif

extern _PNH __newhandler;

_PNH OSA_CDECL _set_new_handler( _PNH pfnHandler );

void * OSA_CDECL operator new(size_t size);
void * OSA_CDECL operator new[](size_t size);
void * OSA_CDECL operator new(size_t size, OsaMemoryPoolType type);
void * OSA_CDECL operator new(size_t cbSize, OSA_MD& Omd);
void   OSA_CDECL operator delete(void *p);
void   OSA_CDECL operator delete[](void *p);
void   OSA_CDECL operator delete(void *p, OSA_MD& Omd);

#if DBG
void * OSA_CDECL operator new(size_t size, char *szFileName, int nLine);
void * OSA_CDECL operator new[](size_t size, char *szFileName, int nLine);
void * OSA_CDECL operator new(size_t size, OsaMemoryPoolType type, char *szFileName, int nLine);

#define NEW ::new (__FILE__, __LINE__)

#endif

#endif  // #ifndef OSA_MEMORY_H
